<%option explicit%>
<%response.buffer=true%>
<!--#include file="admin$db.asp"-->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Cancel order and restore stock
'*********************************************************************************

'700 - Moving to admin folder
dyninclude xmysite2 & "/shopmailformattemplate.asp"
dyninclude xmysite2 & "/shopmail.asp"

const Xorderfailed = "No"
const xorderfailedTemplate = "tmp_orderfail.txt"
ShopCheckAdmin "shopa_displayorders.asp"

dim ordernumber
dim my_system
dim my_from
dim my_fromAddress
dim my_subject
dim my_to
dim my_toAddress
dim attachmentarray(20), attachmentcount
dim htmlformat
dim mailtype
dim body
dim merchant
dim customer
dim Merchantemailformat, customeremailformat
dim maillist(20)
dim Maillistcount
dim Textarray(500)
dim TextCount
dim orderfail, cardfail, confirmmail
dim mailaction, cancelaction, orderid, confirmcancel
mailaction = Request("Mail")
cancelaction = Request("cancel")
confirmcancel = request("Confirm")
orderfail = request("Orderfail")
cardfail = request("Cardfail")
confirmmail = request("confirmmail")

SError = ""
AdminPageHeader
if Mailaction = "" and cancelaction = "" and confirmcancel = "" and orderfail = "" and cardfail = "" and confirmmail = "" then
   orderid = request("oid")
   '6.09 - Precautionary Security Fix
   if orderid > "" then
      if not isnumeric(orderid) then
         ShopError GetLang("langorderidmustbenumeric")
      end if
   end if

   '700 - Product Matching Enhancement
   if getconfig("xproductmatch") = "Yes" then
      if ucase(GetSess("Admintype")) <> "SUPER" then
         dim storematch
         storematch = getstorematch (orderid)
	     if lcase(storematch) = lcase(xShopId) or isnull(storematch) or trim(storematch) = "" then
	     else
	        ShopError GetLang("LangAdminUnauth")
	     end if
      end if
   end if

   DisplayForm
else
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   ValidateData()
   if SError = "" then
      ProcessRequest
      orderid = ""
      DisplayForm
   else
      DisplayForm
   end if
end if
AdminPageTrailer ' Write admin trailer
ShopCloseDatabase dbc

' Display any errors, then basic information nad then generate
sub DisplayForm()
%>
<table width="90%">
  <tr>
    <td align="left"><%ShopWriteHeader "Cancel Order"%></td>
    <td align="right"><a href='shopa_displayorders.asp'><img src="images/admin/main/arrow_left_blue.gif" border="0"><br />
      Order List</a></td>
  </tr>
</table>
<br />
<%
   DisplayErrors
   GenerateDisplayHeaderFlat
   GenerateDisplayBodyHeader
   HtmlWrite "<form name=""shipping"" method=""Post"" action=""shopa_ordercancel.asp"">"

   '700 - 2010.04.22 - cross site script security enhancement
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

   HtmlWrite TableDef
   CreateCustRow "Order Number", "orderid", orderid, "Yes",""
   HtmlWrite TableDefEnd
   HtmlWrite "<br />"
   HtmlWrite "<center><input class=""submitbtn"" type=submit name=cancel value=""" & GetLang("LangCommonCancelOrder") & """></center>"
   addmailingbuttons
   HtmlWrite "</form>"
   GenerateDisplayBodyFooter
end sub

sub ProcessRequest
   if cancelaction<>"" then
      ProcessCancel
      exit sub
   end if
   if Orderfail<>"" then
      ProcessOrderfail
      exit sub
   end if
end sub

' make sure we have what we need
sub ValidateData
   orderid = request("orderid")
   ordernumber = orderid
   if orderid<>"" then
      if not isnumeric(orderid) then
         SError = GetLang("LangStatuSError01") & "<br />"
      end if
   else
      SError = GetLang("LangStatusOrderNumber") & " " & GetLang("langcustrequired")
   end if
end sub

sub DisplayErrors
   if SError<> "" then
      ShopWriteError SError
      SError = ""
   end if
end sub

' set stock stock level, set oprocess=yes and ocanceled=Yes
sub Processcancel
   dim rc
   CheckexistingOrder rc
   if rc>0 then
      ShopWriteError GetLang("LangFormatNone") & " " & orderid
      exit sub
   end if

   '701 - 2011.05.16 - Enhancement: Gift Certificate should be refund if cancel order
   RefundGiftCertAmount dbc
   
   cancelUpdateStock dbc
   UpdateOrderFields dbc, orderid
   ShopWriteHeader GetLang("LangCheckoutCancelled") & " " & GetLang("LangStatusOrderNumber") & " " & orderid
end sub

sub cancelupdatestock (dbc)
   if GetConfig("xstockcontrol")<>"Yes" then exit sub

   '6.50 - stop stock from being updated if order is already cancelled
   dim ors

   dim CatalogId
   dim quantity, strsql, items

   strSQL = "select * FROM oitems where orderid = " & Orderid
   Set items = Server.CreateObject("ADODB.Recordset")
   items.open strSQL, dbc, adOpenDynamic, adLockOptimistic
   do while not items.eof
      '6.50 - stop stock from being updated if order is already cancelled
      Set ors = Server.CreateObject("ADODB.Recordset")
	  '701 - 2010.01.21 - Bug Fix: order status is not checking for updating to stock level
      ors.open "select canceled, ocardtype, oprocessed FROM orders WHERE orderid = " & orderid, dbc, adOpenDynamic, adLockOptimistic
      if not ors.eof then
         quantity = items("numitems")
         CatalogId = items("CatalogId")

         if (ors("canceled") = True) or (isnull(ors("ocardtype"))) then
         else
		    '701 - 2010.01.21 - Bug Fix: order status is not checking for updating to stock level
			if ors("oprocessed") = true or ors("oprocessed") = 1 then UpdateStockLevels CatalogId, quantity, dbc
         end if
      end if
      CloseRecordSet ors
      items.MoveNext
   loop
   CloseRecordSet items
end sub

sub UpdateStockLevels (CatalogId, quantity, dbc)
   dim rsproduct
   dim stock
   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      '6.50.4 Bugs Fix - 08 October 2008
      mysqlupdatestocklevels CatalogId, - (quantity), dbc
      exit sub
   end if
   set rsproduct = Server.createobject ("adodb.recordset")
   sql = "select cstock from products where CatalogId=" & CatalogId
   rsproduct.open SQL, dbc, adOpenKeyset, adLockOptimistic , adcmdText
   if not rsproduct.eof then
      stock = rsproduct("cstock")
      stock = stock + quantity
      rsproduct("cstock") = stock
      rsproduct.update
      ShopWriteHeader GetLang("LangAddUpdate") & "=" & CatalogId & " " & GetLang("LangProductStock") &"=" & stock
   end if
   CloseRecordSet rsproduct
end sub

sub UpdateOrderfields(dbc, orderid)
   dim sql

   '700 - 2010.05.27 - Enhancement: Reset related field while cancel order at shopa_ordercancel.asp
   sql = "Update orders set oprocessed=1, canceled=1, "
   sql = sql & "oaffid = '0', "
   sql = sql & "coupon = NULL, "
   sql = sql & "commission = 0, "
   sql = sql & "opoints = '0', "
   sql = sql & "ocardtype = 'Fail', "
   sql = sql & "ocardno = NULL, "
   sql = sql & "oauthorization = NULL "
   sql = sql & " where orderid=" & orderid
   dbc.execute(sql)
end sub

' See if order really exists
' if yes rc=0 else rc=4
sub CheckexistingOrder (rc)
   rc = 4
   dim rs, sql
   sql = "select * from orders where orderid=" & orderid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      rc = 4
   else
      rc = 0
   end if
   rs.close
   set rs = nothing
end sub

sub MailPerson (toname, toaddress, fromname, fromaddress, subject, tobody, attachmentYesNo)
   dim acount
   SetSess "mailerror", ""
   my_system = GetConfig("xemailsystem") ' mail.mysystem.com
   mailtype = GetConfig("xemailtype") ' aspmail, jmail, cdonts
   my_subject = subject
   my_to = toname
   my_toAddress = toaddress
   my_from = fromname
   my_fromAddress = fromaddress
   if my_toAddress = "" then
      exit sub
   end if
   if my_from = "" then
      my_from = "Unknown"
   end if
   if my_fromAddress = "" then
      my_fromAddress = "unknown@unknown.com"
   end if
   body = tobody
   if GetConfig("xDebug") = "Yes" then
      DebugWrite "mailing to " & toname & " " & toaddress
   end if
   htmlformat = GetSess("EmailFormat")
   if attachmentYesNo = "Yes" then
      acount = attachmentcount
   else
      acount = 0
   end if
   ExecuteMail mailtype, My_from, my_fromaddress, my_to, my_toaddress, my_subject, body, htmlformat, attachmentarray, acount
end sub

sub DoesOrderExist (dbc, orderid, rc, orderrs)
   rc = 4
   dim sql
   sql = "select * from orders where orderid=" & orderid
   Set orderrs = Server.CreateObject("ADODB.Recordset")
   orderrs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if orderRs.eof then
      CloseRecordSet OrderRs
      rc = 4
   else
      rc = 0
   end if
end sub

' Development stopped On Sept 3
' Not fully implemented
sub Addmailingbuttons
   if Xorderfailed<>"Yes" then exit sub
   dim Template, msg
   HtmlWrite "<br /><br /><br />&nbsp;"
   msg = "Your order did not go through"
   HtmlWrite "<input class=""submitbtn"" type=submit name=Orderfail value=""" & msg & """>"
   HtmlWrite "<br /><br />"
end sub

sub ProcessOrderfail
   dim Template, subject
   Template = GetConfig("xorderfailTemplate")
   if Template = "" then
      Template = "tmp_orderfail.txt"
   end if
   Subject = GetConfig("xemailsubject")
   mailgeneric ordernumber, Template, subject
end sub

sub mailgeneric (orderid, Template, subject)
   dim rc, emailformat, customer, stremail, trackingname
   dim name, emailaddress, RSOrder
   dim newsubject
   dim filename, cr, i
   Doesorderexist dbc, orderid, rc, RsOrder
   if rc> 0 then
      SError = GetLang("langformatnone") & " " & orderid & "<br />"
      exit sub
   end if
   filename = Template
   SetupEmailformat filename, emailformat
   SetSess "emailformat", ucase(merchantemailformat)
   ShopTemplateArray Filename, RsOrder, TextArray, TextCount
   customer = ""
   CR = GetMailCR
   for i = 0 to Textcount -1
      customer = customer & TextArray(i) & CR
   next
   customer = RemoveHtml(customer, CR)
   trackingname = rsorder("olastname")
   stremail = rsorder("oemail")
   name = rsorder("ofirstname") & " " & rsorder("olastname")
   newsubject = subject & GetLang("langmailordernumber") & " " & orderid
   MailPerson rsorder("olastname"), rsorder("oemail"), GetConfig("xemailname"), GetConfig("xemail"), newsubject, Customer, "No"
   HtmlWrite GetConfig("xfont") & "Mail sent to " & name & " " & stremail & "<br />"
   HtmlWrite subject & "</font><br />"
   CloseRecordSet rsorder
end sub

'701 - 2011.05.16 - Enhancement: Gift Certificate should be refund if cancel order
sub RefundGiftCertAmount (dbc)
   dim ors,strsql

   strsql = "select canceled, ocardtype, oprocessed,giftcertificate,giftamountused FROM orders WHERE orderid = " & orderid
   Set ors = Server.CreateObject("ADODB.Recordset")
   ors.open strsql, dbc, adOpenForwardOnly, adLockReadOnly
   do while not ors.eof
      if (ors("canceled") = True) or (isnull(ors("ocardtype"))) then
      else
		 UpdateGiftCertAmount ors("giftcertificate"),ors("giftamountused"),dbc
      end if
      ors.MoveNext
   loop
   CloseRecordSet ors
end sub

'701 - 2011.05.16 - Enhancement: Gift Certificate should be refund if cancel order
sub UpdateGiftCertAmount (giftcert, giftcertamount, dbc)
   if isnull(giftcert) then exit sub
   if trim(giftcert) = "" then exit sub
   if isnull(giftcertamount) then exit sub
   if trim(cstr(giftcertamount)) = "" then exit sub
   if trim(cstr(giftcertamount)) = "0" then exit sub
   
   dim rsgiftcert,sqlstr,comparestring
   comparestring = ""& orderid &","& giftcertamount &""
   set rsgiftcert = Server.createobject ("adodb.recordset")
   sqlstr = "select * from gifts where giftnumber='" & giftcert & "' "
   if instr(lcase(xdatabasetype),"mysql") > 0 then
      sqlstr = sqlstr & " and concat(';',giftusedtrace,';') like '%;" & comparestring & ";%' "
   else
      sqlstr = sqlstr & " and ';' + giftusedtrace + ';' like '%;" & comparestring & ";%' "
   end if
   rsgiftcert.open sqlstr, dbc, adOpenKeyset, adLockOptimistic , adcmdText
   dim giftamountremaining
   if not rsgiftcert.eof then
      giftamountremaining = rsgiftcert("giftamountremaining")
      giftamountremaining = giftamountremaining + giftcertamount
      rsgiftcert("giftamountremaining") = giftamountremaining
      rsgiftcert.update
   end if
   CloseRecordSet rsgiftcert
end sub
%>