<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Two subroutines are provided
' Iptocountry (ipaddress, country, countryname)
' returns country abbreviation for example CA
' and name   Canada
' ShopCountryUpdate dbc, orderid, ipcountry, ipcountryname
' if the country does notmatch customers country  two updates to ther order are made
' ocardtype has country appended  Versign CA
' Ipaddress has country appended  555.34.3.99 CANADA
'*********************************************************************************

const iptocountrydb = "iptocountry"
const ipDbLocation = "" ' used for SQL Server
const ipDatabaseType = ""

sub Iptocountry (ipaddress, country, countryname)
   dim ipnodes(5), ipcount, iipx, dbc, i, ipnumber, rs, rc
   ParseRecord ipaddress, ipnodes, ipcount, "."
   for i = 0 to 3
      ipnodes(i) = cdbl(ipnodes(i))
   next
   ipnumber = ipnodes(0) * 256 * 256 * 256 + ipnodes(1) * 256 * 256 + ipnodes(2) * 256 + ipnodes(3)
   OpenIpDatabase dbc, rc
   if rc<>0 then exit sub
   country = "???"
   countryname = "???"
   sql = "select * from iptocountry where ipfrom<=" & ipnumber
   sql = sql & " and ipto>=" & ipnumber
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sqL, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      country = rs("countryshort")
      countryname = rs("countryname")
   end if
   CloseRecordSet rs
   
   '701 - 2011.04.15 - Bug Fix: IPcountry is not working properly
   shopclosedatabase dbc
end sub

sub ShopCountryUpdate (dbc, orderid, ipcountry, ipcountryname)
   dim country, rs, sql, cardtype, ipaddress
   country = GetSess("country")
   if country = ipcountry then exit sub
   sql = "select * from orders where orderid=" & orderid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   cardtype = rs("ocardtype")
   ipaddress = rs("ipaddress")
   CloseRecordSet rs
   cardtype = cardtype& " " & ipcountry
   ipaddress = Ipaddress & " " & ipcountryname
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "update orders set ocardtype="& sqlserverprefixn &"'" & cardtype & "',"
   sql = sql & " ipaddress='" & ipaddress & "'"
   sql = sql & " where orderid=" & orderid
   dbc.execute(sql)
end sub

sub openIpDatabase (dbc, rc)
   dim DbLocation, Database, strconn
   '701 - 2011.04.15 - Bug Fix: IPcountry is not working properly
   if ucase(xdatabasetype) = "SQLSERVER" or ucase(xdatabasetype) = "ODBC" or ucase(xdatabasetype) = ""  or ucase(xdatabasetype) = "DRIVE" or instr(ucase(xdatabasetype), "MYSQL") > 0 then
      OpenSpecialDatabase dbc, rc
   else
      '701 - 2011.04.15 - Bug Fix: IPcountry is not working properly
	  OpenOtherDatabase dbc, Iptocountrydb, ipdblocation,ipDatabaseType
      IPCheckDatabaseOpen dbc, rc
   end if
end sub

' for sqlserver, odbc, mysql
sub OpenSpecialDatabase (dbc, rc)
   dim dblocation,strconn, database 
   dblocation=ipdblocation
   database=iptocountrydb & ".mdb"
   If dblocation<>"" then
      database = dblocation & "\" & database 
   end if
   if ucase(ipdatabasetype)="DRIVE" Then 
      strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & database
   else 
      strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & Server.MapPath(database)
   end if
   '700 - 2010.08.04 - Bug Fix: shopiptocountry issue
   Set dbc = Server.CreateObject("ADODB.Connection")
   on error resume next
   dbc.open strConn
   IPCheckDatabaseOpen strConn, rc
end sub

sub IpCheckDatabaseOpen (conn, rc)
   dim msg
   rc = 0
   if conn.state = adStateOpen then exit sub
   msg = GetLang("LangDatabaseOpenError") & "<br />"
   msg = msg& "<br />" & GetSess("OpenError")
   ShopWriteError msg
   rc = 4
end sub
%>