<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' cross selling routines
'*********************************************************************************

'add cross seelling links.  Formatting in shopproductsubs.asp
sub Handle_CrossSelling (ivalue, parsearray,parseRS)
   if lcase(GetConfig("XCrossSelling"))<>"yes" then
      htmlwrite "<div class=""noproductmessage"">" & getlang("langcommonnoproducts") & "</div>"
      exit sub
   end if
   dim lngcstock, headercaption
   dim tempCatalogId, tempname
   dim strCrossProductIDs,strsql, rs, strmessage, strcdescurl,strurl
   dim fieldtype,rc
   FindInDatabase "CROSSSELLING", strcrossProductids, fieldtype, rc, parsearray
   if rc>0 then
      htmlwrite "<div class=""noproductmessage"">" & getlang("langcommonnoproducts") & "</div>"
      exit sub
   end if
   if strCrossProductids="" then
      htmlwrite "<div class=""noproductmessage"">" & getlang("langcommonnoproducts") & "</div>"
      exit sub
   end if
   
   '701 - 2010.11.01 - Bug Fix: Cross selling products should reading prodcategories
   '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
   strsql = "SELECT "
   strsql = strsql & " distinct "
   strsql = strsql & " p.catalogid from products p, prodcategories cc, categories c "
   strsql = strsql & " where cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
   strsql = strsql & " and p.CatalogId in (" & strcrossproductids & ") "

   'inventory
   strsql = strsql & " AND (p.higherCatalogId is null)"

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql strsql, "p.", "c.", "generateproductmatchsqlsubs"

   '701 - 2010.11.01 - Bug Fix: Cross selling products should reading prodcategories
   dim plist
   plist = ""
   set rs = Server.createobject("ADODB.Recordset")

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   rs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

   do while not rs.eof
      plist = plist & rs("catalogid") & ","
      rs.movenext
   loop
   closerecordset rs
   if plist = "" then
      strsql = ""
	  exit sub
   end if
   plist = mid(plist,1,len(plist)-1)
   strsql = "select * from products p where p.CatalogId In (" & plist & ")"
   
   Headercaption=GetLang("LangCrossSellingMessage")
   FormatCrossSellingProducts dbc, strsql, headercaption,""
end sub

sub FormatCrossSellingProducts (dbc, sql, headercaption, displaylimit)
   dim rs, strxProCatDisplaytemplateinvent, strxProCatDisplaytemplate, limit, dcount

   If Getconfig("Xcrosssellingimage")="Yes" then
      strxProCatDisplaytemplateinvent = getconfig("xProExdCrossSellingTemplateInvent")
      strxProCatDisplaytemplate = getconfig("xProExdCrossSellingTemplate")
   else
      strxProCatDisplaytemplateinvent = getconfig("xProExdCrossSellingTemplateInventNoImage")
      strxProCatDisplaytemplate = getconfig("xProExdCrossSellingTemplateNoImage")
   end if

   if strxProCatDisplaytemplateinvent = "" or strxProCatDisplaytemplate = "" then
      shoperror "xProExdCrossSellingTemplate and xProExdCrossSellingTemplateInvent"& GetLang("langerrmusthavevalue") &""
      exit sub
   end if

   if displaylimit = "" then
      limit = 9999
   else
      limit = clng(displaylimit)
   end if
   dcount = 0
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
   '701 - 2011.12.07 - Bug Fix: Product descirption page is freezing if using sqlserver and customerprices is switched on
   if instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      rs.open sql, dbc, adOpenStatic, adLockReadOnly
   else
      rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
   end if
   
   if not rs.eof then
      selectedprodcutsflag = true
      HtmlWrite "<span class='fontbold'>"& headercaption &"</span><br /><br />"
      do while not rs.eof and dcount<limit
         if rs("hassubproduct") = "Yes" then
            ShopTemplateWrite strxProCatDisplaytemplateinvent, rs, rc
         elseif rs("features")<>"" and isnull(rs("features")) = false then
            ShopTemplateWrite strxProCatDisplaytemplateinvent, rs, rc
         else
            ShopTemplateWrite strxProCatDisplaytemplate, rs, rc
         end if
         rs.movenext
         dcount = dcount + 1
      loop
   else
      htmlwrite "<div class=""noproductmessage"">" & getlang("langcommonnoproducts") & "</div>"
   end if
   closerecordset rs
end sub
%>